class Circuit {


  PVector[] niveau;
  int nombreDePoints = 19;

  Circuit() {
    niveau = new PVector[19];
    niveau[0]  = new PVector(0.0, 0.0);
    niveau[1]  = new PVector(620.0, 0.0);
    niveau[2]  = new PVector(1072.0, 79.0);
    niveau[3]  = new PVector(1392.0, 79.0);
    niveau[4]  = new PVector(1799.0, 0.0);
    niveau[5]  = new PVector(2211.0, 0.0);
    niveau[6]  = new PVector(2323.0, 0.0);
    niveau[7]  = new PVector(2642.0, -66.0);
    niveau[8]  = new PVector(2969.0, -66.0);
    niveau[9]  = new PVector(3233.0, 0.0);
    niveau[10]  = new PVector(3595.0, 0.0);
    niveau[11]  = new PVector(3939.0, -86.0);
    niveau[12]  = new PVector(4142.0, -86.0);
    niveau[13]  = new PVector(4705.0, 140.0);
    niveau[14]  = new PVector(5003.0, -81.0);
    niveau[15]  = new PVector(5212.0, -111.0);
    niveau[16]  = new PVector(5516.0, 69.0);
    niveau[17]  = new PVector(5859.0, 29.0);
    niveau[18]  = new PVector(6280.0, 0.0);
  }


  ///////////////////////////////////////////////////////////////////// 
  float getForceAtTime(float t) {
    t = t % longueur();
    for (int i = 0; i < niveau.length; i++) {
      if (niveau[i].x > t) {
        float dist = niveau[i].x - niveau[i-1].x;
        float position = t - niveau[i-1].x;
        float pourcentage = position / dist;
        return easeInOut(niveau[i-1].y, niveau[i].y, pourcentage);
      }
    }
    return 0;
  }


  ///////////////////////////////////////////////////////////////////// 
  float longueur(){
    return niveau[nombreDePoints-1].x;
  }


  ///////////////////////////////////////////////////////////////////// 
  void display() {
    // affichage
    fill(245, 123, 42, 60); noStroke(); 
    for (int i = 0; i < niveau.length; i++) {
      // on dessine une courbe entre le point et celui d'avant
      if (i!=0) { // sauf pour le premier
        afficherCourbeEaseInOutPleine(niveau[i-1], niveau[i], 0);
      }
    }
    // fin du niveau
    fill(245, 123, 42, 150); stroke(245, 123, 42, 150);
    float tailleDeLaLigneDeFinDeNiveau = 200;
    ligne(new PVector(longueur(), tailleDeLaLigneDeFinDeNiveau/2), new PVector(longueur(),-tailleDeLaLigneDeFinDeNiveau/2));

    
  } 
}
